﻿package com.foxit.general.utils;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import com.foxit.general.activity.FormActivity;
import com.foxit.general.activity.R;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

public class MyFileManager extends ListActivity {
	public static final int RESULTCODE = 2;
	public static final int REQUESTCODE = 2;
	private List<String> items = null;
	private List<String> paths = null;
	private String rootPath = "/";
	private TextView mPath;
	private EditText editText = null;
	private String fileStr = null;
	private String fileName = null;	
	private String folderName = null;	

	@Override
	protected void onCreate(Bundle icicle) {
		super.onCreate(icicle);

		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.fileselect);
		rootPath = Environment.getExternalStorageDirectory().getPath();
		mPath = (TextView) findViewById(R.id.mPath);
		editText = (EditText) findViewById(R.id.fileName);
		Button buttonConfirm = (Button) findViewById(R.id.buttonConfirm);
		buttonConfirm.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				if(fileName != null)
					editText.setText(fileName);
				else
				{
					fileName = editText.getText().toString();
					fileStr = folderName + "/" + fileName;
				}
				Intent data = new Intent(MyFileManager.this, FormActivity.class);
				Bundle bundle = new Bundle();
				bundle.putString("file", fileStr);
				data.putExtra("Result", bundle);
				setResult(RESULTCODE, data);
				finish();
			}
		});
		Button buttonCancle = (Button) findViewById(R.id.buttonCancle);
		buttonCancle.setOnClickListener(new OnClickListener() {

			public void onClick(View v) {
				finish();
			}
		});
		getFileDir(rootPath);
	}

	private void getFileDir(String filePath) {
		mPath.setText(filePath);
		items = new ArrayList<String>();
		paths = new ArrayList<String>();
		File f = new File(filePath);
		File[] files = f.listFiles();
		folderName = filePath;
		if (!filePath.equals(rootPath)) {
			items.add("root");
			paths.add(rootPath);
			items.add("prev");
			paths.add(f.getParent());
		}
		for (int i = 0; i < files.length; i++) {
			File file = files[i];
			items.add(file.getName());
			paths.add(file.getPath());
		}
		setListAdapter(new MyAdapter(this, items, paths));
	}

	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		File file = new File(paths.get(position));
		if (file.isDirectory()) {
			getFileDir(paths.get(position));
		} else {
			fileStr = paths.get(position);
			fileName = file.getName();
			editText.setText(fileName);
		}
	}
}