package com.foxit.general.utils;

import com.foxit.general.activity.FormActivity;
import com.foxit.general.activity.R;
import com.foxit.gsdk.PDFException;
import com.foxit.gsdk.pdf.form.PDFFormField.KeyStrokeEvent;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.InputFilter;
import android.text.TextWatcher;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Window;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;

public class TextfieldActivity extends Activity{
	private EditText editText = null;
	public static final int RESULTCODE = 1;
	public static final int REQUESTCODE = 1;
	protected static final String TAG = "TextfieldActivity";
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setContentView(R.layout.textfield);
		Intent intent = getIntent();
		Bundle bundle = intent.getBundleExtra("key");
		String value = bundle.getString("textValue");	
		int maxlen = bundle.getInt("MaxLen");
		editText = (EditText)findViewById(R.id.editText);
		if(maxlen > 0)
			editText.setFilters(new InputFilter[]{new InputFilter.LengthFilter(maxlen)});
		editText.setText(value);	
		editText.addTextChangedListener(mTextWatcher);
		editText.setOnEditorActionListener(new OnEditorActionListener(){
			public boolean onEditorAction(TextView v, int actionId,
					KeyEvent event) {
				if(actionId == EditorInfo.IME_NULL){
					Intent resIntent = new Intent();
					Bundle bundle = new Bundle();
					String value = editText.getText().toString();
					bundle.putString("ResultValue", value);
					resIntent.putExtra("Result", bundle);
					TextfieldActivity.this.setResult(RESULTCODE, resIntent);
					finish();
					return true;
				}
				return false;
			}	
		});
		
	}
	
	TextWatcher mTextWatcher = new TextWatcher() {  
        private CharSequence temp;  

        @Override  
        public void onTextChanged(CharSequence s, int start, int before, int count) {  
            // TODO Auto-generated method stub  
             temp = s;  
        }  
          
        @Override  
        public void beforeTextChanged(CharSequence s, int start, int count,  
                int after) {  
            // TODO Auto-generated method stub  
        }  
          
        @Override  
        public void afterTextChanged(Editable s) {  
            // TODO Auto-generated method stub  
            int editStart ;  
            int editEnd ;
            editStart = editText.getSelectionStart();  
            editEnd = editText.getSelectionEnd();  
            KeyStrokeEvent event = new KeyStrokeEvent();
			event.currentValue = null;
			event.inputValue = temp.toString();
			event.start = 0;
			event.end = 0;
			event.willCommit = false;
			try {
				boolean ret = FormActivity.field.validateKeyStrokeEvent(event);
				if(ret == false)
				{
					if(editStart > 0)
						s.delete(editStart-1, editEnd);   
					return;
				}
				ret = FormActivity.field.validateValue(temp.toString());
				if(ret == false)
					return;
			} catch (PDFException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Log.w(TAG, FormActivity._FUNC_() + FormActivity.generateMsg(e.getLastError(), "FormField of FormActivity operate exception!!!", true));
			}  
        }  
    };  
	
}