package com.foxit.general.view;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.text.InputType;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.EditText;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import android.widget.Toast;

//An activity call that the project start with, which give the navigation list for directory and PDF pages
public class MainActivity extends Activity
{
	List<HashMap<String, Object>>	listData	  = null;
	ListView	                  fileList	      = null;
	private boolean	              datalistisEmpty	= true;
	private String memsize = "8";

	@Override
	//Project starts here
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.testmain);

		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
		        WindowManager.LayoutParams.FLAG_FULLSCREEN);
		fileList = (ListView) findViewById(R.id.listView1);
		TextView textView = (TextView) findViewById(R.id.fileName);
		fileList.requestChildFocus(textView, fileList);
		fileList.setSelected(true);

		if (Environment.getExternalStorageState().equals(
		        Environment.MEDIA_MOUNTED))
		{
			inflateListView(Environment.getExternalStorageDirectory().getPath());
		} else
		{
			Toast.makeText(MainActivity.this, "Not find sdcard", Toast.LENGTH_SHORT)
				.show();
		}
		fileList.setOnItemClickListener(new MyItemOnClick());
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle("Set Memory Size(MB)");

		final EditText input = new EditText(this);
		input.setInputType(InputType.TYPE_CLASS_NUMBER );
		builder.setView(input);

		builder.setPositiveButton("OK", new DialogInterface.OnClickListener() { 
		   
		    public void onClick(DialogInterface dialog, int which) {
		        memsize = input.getText().toString();
		        if(memsize.length()==0)
		        	memsize = "8";
		    }
		});
		builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
		  
		    public void onClick(DialogInterface dialog, int which) {
		        dialog.cancel();
		    }
		});

		builder.show();	
	}
	
	 @Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// TODO Auto-generated method stub
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.main, menu);
		
		return super.onCreateOptionsMenu(menu);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// TODO Auto-generated method stub
		switch (item.getItemId()) 
		{		
	    	case R.id.action_setmemsize:	
		    	{	
		    		AlertDialog.Builder builder = new AlertDialog.Builder(this);
					builder.setTitle("Set Memory Size(MB)");

					final EditText input = new EditText(this);
					input.setInputType(InputType.TYPE_CLASS_NUMBER );
					builder.setView(input);

					//Input dialogue for text search
					builder.setPositiveButton("OK", new DialogInterface.OnClickListener() { 
					   
					    public void onClick(DialogInterface dialog, int which) {
					        memsize = input.getText().toString();
					        if(memsize.length()==0)
					        	memsize = "8";
					       
					    }
					});
					builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
					  
					    public void onClick(DialogInterface dialog, int which) {
					        dialog.cancel();
					    }
					});

					builder.show();	
		    	}
	      		break;
				
		}
		return true;
	}

	/** 
  	 * brief inflate  data in the current path into list. <br>
  	 * 
	 * @param path					String
	 * 
	 * @return void <br>
	 */	
	//Populate item list for a directory path 
	private void inflateList(String path)
	{
		// TODO Auto-generated method stub
		listData = new ArrayList<HashMap<String, Object>>();
		File file = new File(path);
		File[] listFiles = file.listFiles();
		HashMap<String, Object> map = new HashMap<String, Object>();
		map.put("icon", R.drawable.superfolder);
		map.put("filename", "..");
		map.put("path", path);
		listData.add(map);
		if (listFiles != null)
		{
			for (File f : listFiles)
			{
				map = new HashMap<String, Object>();
				if (f.isDirectory() && !f.getName().startsWith("."))
				{
					map.put("icon", R.drawable.folder);
					map.put("filename", f.getName());
					map.put("path", f.getPath());
					listData.add(map);
				}
			}
			for (File f : listFiles)
			{
				map = new HashMap<String, Object>();
				if (f.getName().endsWith(".pdf"))
				{
					map.put("icon", R.drawable.default_pdf_draw);
					map.put("filename", f.getName());
					map.put("path", f.getPath());
					listData.add(map);
				}
			}
		}

		if (listData.isEmpty())
		{
			datalistisEmpty = true;
		} else
		{
			datalistisEmpty = false;
		}
	}
	
	 /** 
  	 * brief inflate List View which show the data in the current path  <br>
	 *  
	 *  
	 * @param e					MotionEvent
	 * 
	 * @return void <br>
	 */	

	public void inflateListView(String path)
	{

		inflateList(path);
		if (!datalistisEmpty)
		{
			fileList.setAdapter(getListSimpleAdapter());
		}

	}

	//Call FoxitRDK2Activity to browse PDF file using GSDK library
	public class MyItemOnClick implements OnItemClickListener
	{

		@Override
		public void onItemClick(AdapterView<?> parent, View view, int position,
		        long id)
		{

			HashMap<String, Object> map = listData.get(position);
			String path = (String) map.get("path");
			File file = new File(path);
			String parentpath = file.getParentFile().getPath();

			if (position == 0)
			{
				if (path.equals(Environment.getExternalStorageDirectory().getPath()))
				{
					inflateListView(Environment.getExternalStorageDirectory().getPath());
					Toast.makeText(MainActivity.this, "Top Directory",
					        Toast.LENGTH_LONG).show();
				} else
				{
					inflateListView(parentpath);
				}
			} else
			{
				if (file.isDirectory())
				{
					inflateListView(path);
				} else
				{

					Intent intent = new Intent();
					intent.putExtra("fileDir", path);
					intent.putExtra("memsize", memsize);
					intent.setClass(MainActivity.this, OOMActivity.class);
					startActivity(intent);
				}
			}

		}
	}
	 /** 
  	 * brief get the list view adapter <br>
	 *  
	 * 
	 * 
	 
	 * @return void <br>
	 */	
	private ListAdapter getListSimpleAdapter()
	{
		// TODO Auto-generated method stub

		SimpleAdapter adapter = new SimpleAdapter(this, listData,
		        R.layout.list_menu, new String[]
		        { "icon", "filename" }, new int[]
		        { R.id.icon, R.id.fileName });
		return adapter;
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event)
	{
		if (keyCode == KeyEvent.KEYCODE_BACK && event.getRepeatCount() == 0)
		{
			HashMap<String, Object> map = listData.get(0);
			String path = null;
			path = (String) map.get("path");
			File file = null;
			file = new File(path);
			if (file.getParent() != null)
			{
				String parentpath = file.getParentFile().getPath();
				if (path.equals(Environment.getExternalStorageDirectory().getPath()))
				{
					this.finish();
				} else
				{
					inflateListView(parentpath);
				}
			}
			return false;
		}
		return false;
	}

}
