package com.foxit.general.view;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.util.AttributeSet;
import android.view.View;

public class MainView extends View
{
	private Bitmap bitmap;
	private int nStartX = 0;
	private int nStartY = 0;
	private int nCurDisplayX =0;
	private int nCurDisplayY = 0;
	public Bitmap CurrentBitmap = null;
	private float nDisplayX = 0;
	private float nDisplayY = 0;
	private int drawCount = 0;
	
	public MainView(Context context)
	{
		super(context);
	}

	public MainView(Context context, AttributeSet attrs)
	{
		super(context, attrs);
	}

	public void setImageBitmap(Bitmap b) {
		bitmap = b;
		CurrentBitmap = b;
	}

	@Override
	protected void onDraw(Canvas canvas) {
		if(bitmap != null)
			canvas.drawBitmap(CurrentBitmap, 0, 0, null);
		if(drawCount>0)
		{
			if(CurrentBitmap!=null && CurrentBitmap.isRecycled())
			{
				CurrentBitmap.recycle();
				CurrentBitmap = null;
			}
		}
		drawCount++;
	}
	
	public void SetMartix(float CurrentoffsetX,float CurrentoffsetY)
	{
		nStartX = nCurDisplayX - (int)CurrentoffsetX;
		nStartY = nCurDisplayY - (int)CurrentoffsetY;

		if(nStartX > (bitmap.getWidth() - nDisplayX)) nStartX = (int) (bitmap.getWidth() - nDisplayX);
		if(nStartX < 0) nStartX = 0;
		
		if(nStartY > (bitmap.getHeight() - nDisplayY)) nStartY = (int) (bitmap.getHeight() - nDisplayY);
		if(nStartY < 0) nStartY = 0;
		
		nCurDisplayX = nStartX;
		nCurDisplayY = nStartY;
		CurrentBitmap = Bitmap.createBitmap(bitmap, nStartX, nStartY,bitmap.getWidth() - nStartX, bitmap.getHeight()- nStartY);
	}
	
	public void setDisplay(float nWidth,float nHeight)
	{
		nDisplayX = nWidth;
		nDisplayY = nHeight;
	}
}
